%define name xsw
%define xswver 1.40.5
%define release 1

%define dataver 1.33d
%define imagever 1.7
%define soundver 1.4

%define xswdatadir %{_datadir}/games/xshipwars
%define xswimgdir %{xswdatadir}/images
%define xswsnddir %{xswdatadir}/sounds

%define xswserveruser swserv
%define xswserverhomedir %{_libdir}/swserv
%define htmldir /var/www/html/swserv

%define _iconsdir /usr/share/icons
%define _miconsdir /usr/share/icons/mini
%define _liconsdir /usr/share/pixmaps

Summary: A starship combat game with some Star Trek elements
Name: %{name}
Version: %{xswver}
Release: %{release}
Copyright: GPL + additions (see LICENCE)
Group: X11/Games
URL: http://wolfpack.twu.net/ShipWars/XShipWars/
Source: http://www.battlefieldlinux.com/download/%{name}-%{version}.tar.bz2
Source1: ftp://fox.mit.edu/pub/xsw/xswdata%{dataver}.tar.bz2
Source2: ftp://fox.mit.edu/pub/xsw/stimages%{imagever}.tar.bz2
Source3: ftp://fox.mit.edu/pub/xsw/stsounds%{soundver}.tar.bz2
Source4: swservd.init
Source5: default.conf
Source6: swservd.logrotate
Source7: blitstd.cpp.bz2
Source8: %{name}_48x48.xpm
Source9: %{name}_32x32.xpm
Source10: %{name}_16x16.xpm
Patch0: xsw1.33i-megaloman-client.patch
Patch1:	xsw.monitor.patch.bz2
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

%package client
Summary: XShipWars client
Group: X11/Games
Requires: %{name}-client-data, %{name}-client-images

%ifnarch i586 i686
%package client-data
Summary: XShipWars client data package
Version: %{xswver}_%{dataver}
Group: X11/Games
PreReq: %{name}-client

%package client-images
Summary: XShipWars client image set package
Version: %{xswver}_%{imagever}
Group: X11/Games
PreReq: %{name}-client

%package client-sound
Summary: XShipWars client sound set package
Version: %{xswver}_%{soundver}
Group: X11/Games
PreReq: %{name}-client
%endif

%package server
Summary: XShipWars server
Group: X11/Games
Prereq: /usr/sbin/useradd

%package server-monitor
Summary: XShipWars server monitor
Group: X11/Games
PreReq: %{name}-server

%package unvedit
Summary: XShipWars universe editor
Group: X11/Games

%description
XShipWars is a game similar in appearance to Ambrosia's
Escape Velocity, with a Star Trek twist.

%description client
XShipWars client

%ifnarch i586 i686
%description client-data
XShipWars client data package

%description client-images
XShipWars client image set package

%description client-sound
XShipWars client sound set package
%endif

%description server
XShipWars server

%description server-monitor
XShipWars server monitor

%description unvedit
XShipWars universe editor

%prep
%setup
bzcat %{SOURCE7} > client/blitstd.cpp
#%patch0 -p1	# XXX we'll see later
%patch1 -p0
pushd unvedit
ln -s ../client/mathutil.h .
ln -s ../client/rect.h .
popd

%build
%configure

if [ "$SMP" != "" ]; then
  MAKE="make -j$SMP"
else
  MAKE=make
fi

# client
#pushd client
#$MAKE -f Makefile.Linux \
#	CFLAGS="-D__USE_BSD -DUSE_XSHM -DHAVE_ESD -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS" \
#	LIB="-lm -lX11 -lXpm -lXext -lesd -laudiofile"
#popd
make CFLAGS="-D__USE_BSD -DUSE_XSHM -DHAVE_ESD -Dc_plusplus -D__cplusplus -funroll-loops $RPM_OPT_FLAGS" \
	LIB="-lm -lX11 -lXpm -lXext -lesd -laudiofile" \
	client_linux

# server
#pushd server
#$MAKE -f Makefile.Linux \
#	CFLAGS="-D__USE_BSD -DPLUGIN_SUPPORT -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS"
#popd
make CFLAGS="-D__USE_BSD -DPLUGIN_SUPPORT -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS" \
	server_linux

# server monitor
#pushd monitor
#$MAKE -f Makefile.Linux \
#	CFLAGS="-D__USE_BSD -funroll-loops -DUSE_XSHM -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS"
#popd
make CFLAGS="-D__USE_BSD -funroll-loops -DUSE_XSHM -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS" \
	monitor_linux

# universe editor
#pushd unvedit
#$MAKE -f Makefile.Linux \
#	CFLAGS="-D__USE_BSD -DUSE_XSHM -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS"
#popd
make CFLAGS="-D__USE_BSD -DUSE_XSHM -Dc_plusplus -D__cplusplus $RPM_OPT_FLAGS" \
	unvedit_linux

%install
rm -rf $RPM_BUILD_ROOT

# client
#pushd client
#make -f Makefile.Linux PREFIX="$RPM_BUILD_ROOT%{_prefix}" install
#popd
make PREFIX="$RPM_BUILD_ROOT%{_prefix}" client_install_unix
# icons
install -D -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_miconsdir}/%{name}.xpm 
install -D -m644 %{SOURCE3} $RPM_BUILD_ROOT%{_iconsdir}/%{name}.xpm 
install -D -m644 %{SOURCE4} $RPM_BUILD_ROOT%{_liconsdir}/%{name}.xpm

%ifnarch i586 i686
# client data
mkdir -p $RPM_BUILD_ROOT%{xswdatadir}
bunzip2 -dc %{SOURCE1} | tar -xf - -C $RPM_BUILD_ROOT%{xswdatadir}

# client images
mkdir -p $RPM_BUILD_ROOT%{xswimgdir}
bunzip2 -dc %{SOURCE2} | tar -xf - -C $RPM_BUILD_ROOT%{xswdatadir}

# client sound
mkdir -p $RPM_BUILD_ROOT%{xswsnddir}
bunzip2 -dc %{SOURCE3} | tar -xf - -C $RPM_BUILD_ROOT%{xswdatadir}
%endif

# server
#pushd server
#make -f Makefile.Linux PREFIX="$RPM_BUILD_ROOT%{_prefix}" \
#	SWSERV_BIN_DIR="$RPM_BUILD_ROOT%{_bindir}" \
#	SWSERV_DB_DIR="$RPM_BUILD_ROOT%{_var}/lib/swserv/db" \
#	SWSERV_ETC_DIR="$RPM_BUILD_ROOT%{_sysconfdir}/swserv" \
#	SWSERV_LOGS_DIR="$RPM_BUILD_ROOT%{_var}/log/swserv" \
#	SWSERV_HTML_DIR="$RPM_BUILD_ROOT%{htmldir}" \
#	SWSERV_TMP_DIR="$RPM_BUILD_ROOT%{_var}/tmp/swserv" \
#	install
#popd
make PREFIX="$RPM_BUILD_ROOT%{_prefix}" \
	SWSERV_BIN_DIR="$RPM_BUILD_ROOT%{_bindir}" \
	SWSERV_DB_DIR="$RPM_BUILD_ROOT%{_var}/lib/swserv/db" \
	SWSERV_ETC_DIR="$RPM_BUILD_ROOT%{_sysconfdir}/swserv" \
	SWSERV_LOGS_DIR="$RPM_BUILD_ROOT%{_var}/log/swserv" \
	SWSERV_HTML_DIR="$RPM_BUILD_ROOT%{htmldir}" \
	SWSERV_TMP_DIR="$RPM_BUILD_ROOT%{_var}/tmp/swserv" \
	server_install_unix

install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/swserv
mkdir -p $RPM_BUILD_ROOT%{xswserverhomedir}/plugins

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/swservd

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/swserv

# server monitor
#pushd monitor
#make -f Makefile.Linux PREFIX="$RPM_BUILD_ROOT%{_prefix}" \
#	DIR_SWSERV="$RPM_BUILD_ROOT%{xswserverhomedir}" install
#popd
make PREFIX="$RPM_BUILD_ROOT%{_prefix}" \
	GAMES_BIN="$RPM_BUILD_ROOT%{xswserverhomedir}/bin" monitor_install_unix

# universe editor
#pushd unvedit
#make -f Makefile.Linux PREFIX="$RPM_BUILD_ROOT%{_prefix}" install
#popd
make PREFIX="$RPM_BUILD_ROOT%{_prefix}" unvedit_install_unix

%ifnarch i586 i686
%files
%defattr(-,root,root)
%doc CREDITS LICENSE README TODO
%endif

%files client
%defattr(-,root,root)
%attr(0555,root,root) %{_prefix}/games/xsw
%dir %{xswdatadir}
%dir %{xswdatadir}/etc
%config %{xswdatadir}/etc/xshipwarsrc
%config %{xswdatadir}/etc/universes
%dir %{xswimgdir}
%{_miconsdir}/%{name}.xpm
%{_iconsdir}/%{name}.xpm
%{_liconsdir}/%{name}.xpm

%ifnarch i586 i686
%files client-data
%defattr(-,root,root)
%{xswdatadir}/etc/generic.cht
%{xswdatadir}/etc/main.page
%{xswdatadir}/etc/default.ocsn
%{xswdatadir}/etc/destroyed.page
%{xswdatadir}/etc/terminus.ocsn
%dir %{xswimgdir}/client
%{xswimgdir}/client/*
%dir %{xswimgdir}/destroyed.page
%{xswimgdir}/destroyed.page/*
%dir %{xswimgdir}/effects
%{xswimgdir}/effects/*
%dir %{xswimgdir}/main.page
%{xswimgdir}/main.page/*

%files client-images
%defattr(-,root,root)
%{xswimgdir}/default.isr
%dir %{xswimgdir}/celestial
%{xswimgdir}/celestial/*
%dir %{xswimgdir}/misc
%{xswimgdir}/misc/*
%dir %{xswimgdir}/projectiles
%{xswimgdir}/projectiles/*
%dir %{xswimgdir}/stations
%{xswimgdir}/stations/*
%dir %{xswimgdir}/vessels
%{xswimgdir}/vessels/*

%files client-sound
%defattr(-,root,root)
%dir %{xswsnddir}
%{xswsnddir}/*
%endif

%files server
%defattr(-,root,root)
%{_bindir}/swserv
%attr(-,%{xswserveruser},root) %dir %{_var}/lib/swserv/db
%attr(-,%{xswserveruser},root) %{_var}/lib/swserv/db/*
%attr(-,%{xswserveruser},root) %dir %{_sysconfdir}/swserv
%config %attr(-,%{xswserveruser},root) %{_sysconfdir}/swserv/*
%attr(-,%{xswserveruser},root) %dir %{_var}/log/swserv
%attr(-,%{xswserveruser},root) %dir %{htmldir}
%attr(-,%{xswserveruser},root) %dir %{_var}/tmp/swserv
%dir %{xswserverhomedir}
%dir %{xswserverhomedir}/plugins
%{_sysconfdir}/rc.d/init.d/swservd

%files server-monitor
%defattr(-,root,root)
%{xswserverhomedir}/bin/monitor
%dir %{xswimgdir}/monitor
%{xswimgdir}/monitor/*

%files unvedit
%defattr(-,root,root)
%{_prefix}/games/unvedit
%dir %{xswimgdir}/unvedit
%{xswimgdir}/unvedit/*

%pre server
# add user
/usr/sbin/useradd -r %{xswserveruser} > /dev/null 2>&1 || :

%post server
/sbin/chkconfig --add swservd

%preun server
if [ $1 = 0 ] ; then
	/sbin/service swservd stop > /dev/null 2>&1
	/sbin/chkconfig --del swservd
fi

%postun server
if [ $1 = 0 ] ; then
	userdel %{xswserveruser} >/dev/null 2>&1 || : 
fi

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed May  2 2001 Peter Hanecak <hanecak@megaloman.sk>
- updated to 1.40.5
- incorporated stuff from Guillaume Rousse's <g.rousse@linux-mandrake.com>
  1.40.5-2mdk package:
  - blitstd.cpp
  - xsw.monitor.patch.bz2
  - icons
- stimages updated to 1.7

* Fri Jan 12 2001 Peter Hanecak <hanecak@megaloman.sk>
- global/printerw.cpp patch to fix missing '#include <unistd.h>'

* Sun Sep 17 2000 Peter Hanecak <hanecak@megaloman.sk>
- updated URL
- client/netsend.cpp patch by stimits@battlefieldlinux.com
- server/eco.cpp patch by stimits@battlefieldlinux.com

* Fri Sep  8 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 1.33i
- spec reworked

* Sun Jan 2 2000 Charles E. Leiserson, Jr. <locutus@mit.edu>
- first RPM release
